/*
 * RiskScape™ Copyright New Zealand Institute for Earth Science Limited
 * (Earth Sciences New Zealand) is distributed for research purposes only
 * under the terms of AGPLv3.
 *
 * RiskScape™ Copyright 2026 New Zealand Institute for Earth Science
 * Limited (Earth Sciences New Zealand). All rights reserved. Source code
 * available under the AGPLv3.
 * 
 * This program is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Affero General Public License as published by the Free
 *  Software Foundation, either version 3 of the License, or (at your option) any
 *  later version.
 * 
 * This program is distributed for RESEARCH PURPOSES ONLY, in the hope that it will
 * be useful for research and education initiatives.
 * 
 * If you are not a researcher, or you are a researcher who wishes to use this
 * program on terms other than AGPLv3 (including those who wish to restrict the
 * distribution of any source code created using this program), please contact:
 * https://riskscape.org.nz
 * 
 * This program is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Affero General Public License for more details.  You should have received a copy
 * of the GNU Affero General Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * By way of summary only, under the AGPLv3:
 *     • Permissions of this strongest copyleft license are conditioned
 *       on making available complete source code of licensed works and
 *       modifications, which include larger works using a licensed work,
 *       under the same license.
 *     • Copyright and license notices must be preserved.
 *     • Contributors provide an express grant of patent rights.
 *     • When a modified version is used to provide a service over a
 *       network, the complete source code of the modified version must be made
 *       available.
 */
package nz.org.riskscape.netcdf;

import java.io.IOException;
import java.nio.file.Path;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.google.common.collect.ImmutableMap;

import lombok.Getter;
import nz.org.riskscape.engine.Engine;
import nz.org.riskscape.engine.data.relation.RelationBookmarkParams;
import nz.org.riskscape.engine.data.relation.RelationBookmarkResolver;
import nz.org.riskscape.engine.problem.GeneralProblems;
import nz.org.riskscape.engine.relation.Relation;
import nz.org.riskscape.problem.Problems;
import nz.org.riskscape.problem.ResultOrProblems;
import ucar.nc2.Variable;
import ucar.nc2.dataset.NetcdfDataset;
import ucar.nc2.dataset.NetcdfDatasets;

public class NetCDFResolver extends RelationBookmarkResolver<NetCDFResolver.Parameters> {

  public static class Parameters extends RelationBookmarkParams {

    public List<String> getIncludeLayerList() {
      String includedLayers = layer.orElse("").trim();
      if ("".equals(includedLayers)) {
        return Collections.emptyList();
      }
      return Arrays.stream(includedLayers.split(","))
          .map(param -> param.trim())
          .collect(Collectors.toList());
    }
  }

  @Getter
  private final Map<String, String> extensionsToFormats = ImmutableMap.of("nc", "netcdf");

  public NetCDFResolver(Engine engine) {
    super(engine);
  }

  @Override
  protected ResultOrProblems<Relation> createRawRelationFromBookmark(Parameters params) {
    // The NetCDF API's only work with local files. So we use getBookmarkedPath which will fetch remote
    // resources if that's what we have been given.
    ResultOrProblems<Path> bookmarkedPath = getBookmarkedPathOr(params);
    if (bookmarkedPath.hasProblems()) {
      return ResultOrProblems.failed(bookmarkedPath.getProblems());
    }
    try {
      NetcdfDataset ncd = NetcdfDatasets.openDataset(bookmarkedPath.get().toString());
      List<String> includeLayers = params.getIncludeLayerList();
      if (includeLayers.isEmpty()) {
        // no layers chosen, then we roll the dice and use the first var
        includeLayers = Arrays.asList(ncd.getVariables().get(0).getShortName());
      }
      for (String layer : includeLayers) {
        if (ncd.findVariable(layer) == null) {
          List<String> available = ncd.getVariables().stream()
              .map(Variable::getShortName)
              .collect(Collectors.toList());
          return ResultOrProblems.failed(GeneralProblems.get().notAnOption(layer, "layer", available));
        }
      }
      return NetCdfRelation.of(ncd, includeLayers);

    } catch (IOException e) {
      return ResultOrProblems.failed(Problems.caught(e));
    }
  }
}
